%ext ck4
%version 1.4

#Load the modified loading screen
%patchfile $1fe47 ck4load.bin 

#Load the modified graphics
%egahead EGAHEAD.CK4

#Story text file
%patchfile $1EE40 "STORY.CK4"

#Load the modified levels
%maphead maphead.ck4

#Load the modified tile info
%patchfile $249C2 tiles.tli

#Terminator text palette:
%patch $2F078 $00 $04 $04 $1C $01 $01 $01 $01     #Dark colors
              $11 $11 $11 $11 $13 $13 $13 $13 $00 #Light colors (and border color)

#High Score Names
%patch $33234 "Commander Keen   " $00
%patch $33274 "Princess Lindsey " $00
%patch $332B4 "Berkeloid        " $00
%patch $332F4 "Dopefish         " $00
%patch $33334 "Blue Bird        " $00
%patch $33374 "Arachnut         " $00
%patch $333B4 "Skypest          " $00
%patch $333F4 "Mimrock          " $00

#Level text
%patch $1F040 "Sunnylands " $00 #Worldmap
%patch $1F050 " Bounder Road  " $00 #Level 1
%patch $1F060 "  Food Street  " $00 #Level 2
%patch $1F070 "  Cluedonnia   " $00 #Level 3
%patch $1F090 "Pyramid of Puns" $00 #Level 4
%patch $1F0B0 "   Life Lake   " $00 #Level 5
%patch $1F0C0 "Pyramid of Suns" $00 #Level 6
%patch $1F0D0 " Foggy Shelter " $00 #Level 7
%patch $1F0E0 "  Glacierden   " $00 #Level 8
%patch $1F0F0 " Relic Grotto  " $00 #Level 9
%patch $1F100 "  Clear City   " $00 #Level 10
%patch $1F110 " Pyramid of Secrets " $00 #Level 11
%patch $1F130 "  Oven Island  " $00 #Level 12
%patch $1F150 "Isle of Deadly"                  $0A #Level 13
              "     Pools     " $00
%patch $1F180 "Cavity of Clouds" $00 #Level 14
%patch $1F1A0 "Pyramid of Ends" $00 #Level 15
%patch $1F1B0 "   Dumb Well   " $00 #Level 16
%patch $1F1C0 " Flooded Fort  " $00 #Level 17

#Level entry text
%level.entry 0 Keen checks out 
the Sunnylands

%level.entry 1 Keen hops through   
 Bounder Road     

%level.entry 2 Keen hikes into
Food Street 

%level.entry 3 Keen looks around 
Cluedonnia          

%level.entry 4 Keen laughs in the  
 Pyramid of Puns           

%level.entry 5 Keen runs around  
 the Life Lake     

%level.entry 6 Keen steps in the 
 Pyramid of Suns  

%level.entry 7 Keen enters the   
Foggy S. 

%level.entry 8 Keen shivers in     
 Glacierden         

%level.entry 9 Keen searches across
 R.G.  

%level.entry 10 Keen dashes into
Clear City     

%level.entry 11 Keen questions the 
 Pyramid of Secrets 

%level.entry 12 Keen pants and pants 
in Oven Island       

%level.entry 13 Keen quivers in the   
Isle of Deadly    
 Pools             

%level.entry 14 Keen screams loudly in 
 the Cavity of Clouds  
         

%level.entry 15 Keen gulps in the   
Pyramid of Ends

%level.entry 16 Keen dives into the   
 Dumb Well 

%level.entry 17 Keen feels amazed in 
the Flooded Fort   

%level.entry 18 Keen plays around 
the Bean-with-Bacon 
Megarocket

#You didn't make it past... window
%patch $2F191 "Exit to Sunnylands " $00

#Music
%patch $2F206 $00 $00 $04 $00 $03 $00 $03 $00 $02 $00 $03 $00 $02 $00 $01 $00 $01 $00 $03 $00 $04 $00 $02 $00 $02 $00 $02 $00 $04 $00 $02 $00 $01 $00 $01 $00 $05 $00 $05 $00 

#Council Members text
%patch $30C17 "Oh thank you so much" $0A
              "for rescuing me!" $0A
              "I'll be more aware" $0A
              "next time I hike." $00

%patch $30BB3 "....Uh, wasn't there" $0A
              "someone that's in" $0A
              "water and yet talks" $0A
              "normal? Eh, I" $0A
              "will be more aware." $00

#Council Members text - Keen's replies
%patch $30A71 "One down, seven more" $0A
              "to find!" $00

%patch $30A92 "You better be more" $0A
              "careful!" $00

%patch $30AB3 "Ok, just go." $00

%patch $30AC0 "Hm, maybe you should" $0A
              "get a gun and maybe" $0A
              "a pogo next time." $00

%patch $30B13 "Just don't get" $0A
              "trapped in another" $0A
              "place!" $00

%patch $30B44 "At least you aren't" $0A
              "Princess Peach." $00

%patch $30B00 "REAL careful!" $00

%patch $30B6B "Ah, finally! Now we" $0A
              "can see how's" $0A
              "Mortimer doing!" $0A
              "Let's go!" $00

#Hint level 5
%patch $30999 "I heard the Pyramid of" $0A
              "Secrets has interesting" $0A
              "stuff. It might help." $00

%patch $309FA "Interesting" $0A
              "stuff? Hm, there" $0A
              "could be." $00

#Hint level 7
%patch $3094C "Have you checked the" $0A
              "Relic Grotto? I think" $0A
              "there's a wetsuit in" $0A
              "there..." $00

%patch $309E3 "Wow, thanks!" $00

#Wetsuit Text
%patch $30A4B "Gnosticus IV is like" $0A
              "a wetsuit store." $00

#Foot location 1:
#If Keen is ABOVE this, it will screw up
%patch $DE43 $3E
%patch $DE58 $32

#Location 2: (When exiting POTF)
#If Keen is BELOW this, it will screw up
%patch $DE78 $1E
%patch $DE8C $1E

#Council Janitor text
%patch $1F580 "Ah, hello there, cus-" $0A
              "tomer! It's been some" $0A
              "time since the last time" $0A
              "I had one.   " $00

%patch $1F5E0 "Anyway, welcome to" $0A
              "Super Duper Stuff!" $0A
              "Looking for something?" $00

%patch $1F630 $0A
              "Why are you dres-" $00

%patch $1F650 "So I can attract" $0A
              "customers!" $00


################################################################################
# Version Info
################################################################################

%patch $20D71	# Keen 4 startup screen
	"U" $1B
	"n" $1B
	"o" $1B
	"f" $1B
	"f" $1B
	"i" $1B
	"c" $1B
	"i" $1B
	"a" $1B
	"l" $1B
	" " $1B
	"B" $1B
	"u" $1B
	"g" $1B
	"f" $1B
	"i" $1B
	"x" $1B
	" " $1B
	"R" $1B
	"e" $1B
	"l" $1B
	"e" $1B
	"a" $1B
	"s" $1B
	"e" $1B
	" " $1B
	"(" $1B
	"2" $1B
	"0" $1B
	"2" $1B
	"0" $1B
	"-" $1B
	"0" $1B
	"9" $1B
	"-" $1B
	"2" $1B
	"2" $1B
	")" $1B


#####################
# Underwater Levels #
#####################

# The following two patches allow you to use any number of underwater levels in
# a Keen 4 mod. Instead of checking if the current level number is 17, this
# makes the game check if the current level has a swimming Keen in it.
# Note that this will automatically disable the worldmap scrolling for level 17
# if that level has no swimming Keen in it.
#
# Also keep in mind that worldmap scrolling doesn't allow the player to exit
# the level to the left or to the right, you will need additional patches for
# that.
#
# (lumpneeded for swimming Keen is at dseg:CB7B)

# always use worldmap scrolling when level has a swimming Keen:
%patch $9056
	$83 $3E $CB7Bw $00	#	cmp	lumpneeded, 0
	$75			#	jnz	...

# always use dead swimming Keen states when level has swimming Keen:
%patch $CC2A
	$83 $3E $CB7Bw $00	#	cmp	lumpneeded, 0
	$74			#	jz	...

# OPTIONAL:
# use underwater message for oracle member when level has swimming keen:
%patch $F50D
	$83 $3E $CB7Bw $00	#	cmp	lumpneeded, 0
	$74			#	jz	...


################################################################################
# Customized Screen Update Code For KEEN4 v1.4 (EGA)
# Copyright (c) 2019 K1n9_Duk3
#
# This software is provided 'as-is', without any express or implied warranty. In
# no event will the authors be held liable for any damages arising from the use
# of this software.
#
# Permission is granted to anyone to use this software for any purpose, including
# commercial applications, and to alter it and redistribute it freely, subject to
# the following restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not claim
#    that you wrote the original software. If you use this software in a product,
#    an acknowledgment in the product documentation would be appreciated but is
#    not required.
#
# 2. Altered source versions must be plainly marked as such, and must not be
#    misrepresented as being the original software.
#
# 3. This notice may not be removed or altered from any source distribution.
################################################################################

#replace the v1.4 delay code with my custom VW_SetScreen code
#(my VW_SetScreen is bigger than the one in v1.4)
%patch $1E7F9
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$BA $03DAw		#	mov	dx, 3DAh
	$FA			#	cli
				#@l1:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$74 $FB			#	jz	@l1
				#@l2:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$75 $FB			#	jnz	@l2
	$8B $4E $06		#	mov	cx, [bp+arg_start]
	$BA $03D4w		#	mov	dx, 3D4h
	$B0 $0C			#	mov	al, 0Ch
	$EE			#	out	dx, al
	$42			#	inc	dx
	$8A $C5			#	mov	al, ch
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$B0 $0D			#	mov	al, 0Dh
	$EE			#	out	dx, al
	$8A $C1			#	mov	al, cl
	$42			#	inc	dx
	$EE			#	out	dx, al
	$F7 $06 $7A14w $0001w	#	test	fixjerky, 1
	$74 $03			#	jz	@l3
	$E8 $0053w		#	call	WaitVBL
				#@l3:
	$F7 $06 $7ADEw $0001w	#	test	nopan, 1
	$75 $0C			#	jnz	l4
	$BA $03C0w		#	mov	dx, 3C0h
	$B0 $33			#	mov	al, 33h
	$EE			#	out	dx, al
	$EB $00			#	jmp	$
	$8A $46 $08		#	mov	al, [bp+arg_pan]
	$EE			#	out	dx, al
				#@l4:
	$F7 $06 $7A14w $0001w	#	test	fixjerky, 1
	$75 $03			#	jnz	@l5
	$E8 $0034w		#	call	WaitVBL
				#@l5:
	$FB			#	sti
	$5D			#	pop	bp
	$CB			#	retf

#replace the start of VW_SetScreen with a jump into my new code (see above):
%patch $1E87A
	$E9 $FF7Cw

#and overwrite the rest of the old VW_SetScreen code with my WaitVBL code:
	$8B $1E $A53Dw		#	mov	bx, word ptr TimeCount
	$BA $03DAw		#	mov	dx, 3DAh
				#@wait:	
	$FB			#	sti
	$EB $00			#	jmp	short $
	$FA			#	cli
	$EC			#	in	al, dx
	$A8 $08			#	test	al, 8
	$75 $0A			#	jnz	@done
	$A1 $A53Dw		#	mov	ax, word ptr TimeCount
	$2B $C3			#	sub	ax, bx
	$3D $0001w		#	cmp	ax, 1
	$76 $ED			#	jbe	@wait
				#@done:
	$C3			#	retn

################################################################################
# End of Customized Screen Update Code
################################################################################

########################################
# Free Graphics Before Loading A Level #
########################################

#Free sprites and tiles before loading a level
%patch $61DD
	$74 $0A			#	jz	no_demo
	$C7 $06 $7A6Cw $0002w	#	mov	gamestate_difficulty, 2
	$33 $C0			#	xor	ax, ax
	$EB $03			#	jmp	init_rndt
				#no_demo:
	$B8 $0001w		#	mov	ax, 1
				#init_rndt:
	$50			#	push	ax
	$9A $1D020002rl		#	call	US_InitRndT
	$58			#	pop	ax
	$9A $05C40006rl		#	call	FreeUpMemory
	$90 $90 $90 $90 $90 $90

#Don't free the paddle war sprites (in case loading a game fails)
%patch $5C4B $0081w	# default: $007Cw

##################
# Memory Related #
##################

# Fix error in XMS size calculation
%patch $157C2
	$BB $0010w	#	mov	bx, 16
	$F7 $E3		#	mul	bx
	$01 $06 $A017w	#	add	..., ax
	$11 $16 $A019w	#	adc	..., dx


# Lock text buffers to avoid "PageLayout: Text not headed with ^P" error

# CacheAndLock routine (returns grsegs offset in AX):
%patch $18793
	$55		#	push	bp
	$8B $EC		#	mov	bp, sp
	$57		#	push	di
	$8B $7E $06	#	mov	di, [bp+arg_0]
	$57		#	push	di
	$9A $12A61117rl	#	call	CA_CacheGrChunk
	$58		#	pop	ax
	$B8 $0001w	#	mov	ax, 1
	$50		#	push	ax
	$D1 $E7		#	shl	di, 1
	$81 $C7 $7AEDw	#	add	di, offset grsegs
	$57		#	push	di
	$9A $155e0AD5rl	#	call	MM_SetLock
	$83 $C4 $04	#	add	sp, 4
	$8B $C7		#	mov	ax, di
	$5F		#	pop	di
	$5D		#	pop	bp
	$CB		#	retf
# Note: this overwrites the unused SDL_TimingService code (2 bytes left unused)

# Use CacheAndLock instead of CA_CacheGrChunk to cache the text chunks
%patch $9BA8 $18740053rl	# for the help texts
%patch $9CBC $18740053rl	# for the ending text


# Make CA_UpLevel flow into CA_ClearMarks so we don't load more	than we need
%patch $13F4B $EB $30


###################
# Fix Engine Bugs #
###################

# Avoid crashing when trying to draw characters that don't exist in the font:
%patch $354EA $08BBw


# Make VW_ClearVideo abort if screenseg is NULL:
%patch $1D383
	$83 $3E $A7AEw $00	#	cmp	screenseg, 0
	$74 $26			#	jz	done
	$B8 $0000w		#	mov	ax, 0
#this patch overwrites some code that effectively sets AX to 0, that's why the
#new code also sets AX to 0 at the end


%end
